using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Pd5000pWrap; 

namespace OutputLatch
{
	/// <summary>
	///---------------------------------------------------------------------------------
	///                       OutputLatchTv̐
	///---------------------------------------------------------------------------------
	///@o͓ZbgɊւ铮mFłTvłB
	///@o͓Zbg̕@łAOTSTB,߂ɂ@ƃ^C}Pɂ@܂B
	///@OTSTBɊւẮAM̕ωAオÂǂŏo͂邩I܂B
	///@^C}PɊւẮA^C}lƒPʂI܂B
	///@IƏĺA^C}Tv̂̂ƓłB
	///@b`o̓f[^T̃p^[I܂B
	///@o͓Zbg̎sƂāAߎs{^ƃ^C}Ps{^ōs܂B
	/// 
	///	@07/11/26	C by HIDEKI
	///	
	///---------------------------------------------------------------------------------	 
	///</summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Button OpenButton;
		private System.Windows.Forms.Button CloseButton;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Button WriteButton;
		private System.Windows.Forms.Button OutputExeButton;
		private System.Windows.Forms.Button Timer1ExeButton;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Label BoardMsg;
		private System.Windows.Forms.ComboBox BoardKind;
		private System.Windows.Forms.ComboBox SwitchKind;
		private System.Windows.Forms.RadioButton RadioOutStbUp;
		private System.Windows.Forms.RadioButton RadioOutStbDown;
		private System.Windows.Forms.RadioButton RadioWriteSlct1;
		private System.Windows.Forms.RadioButton RadioWriteSlct2;
		private System.Windows.Forms.RadioButton RadioWriteSlct3;
		private System.Windows.Forms.RadioButton RadioWriteSlct4;
		private System.Windows.Forms.RadioButton RadioWriteSlct5;
		private System.Windows.Forms.ComboBox CmbUnit;
		private System.Windows.Forms.CheckBox CheckOtStbCmd;
		private System.Windows.Forms.CheckBox CheckTimer1;
		private System.Windows.Forms.Label Timer1Exe;
		private System.Windows.Forms.Label UnitExe;
		private System.Windows.Forms.ComboBox CmbTimer1;
		private System.Windows.Forms.Timer timer1;

		private static int m_hBoard = 0;	// {[hnhNA
		private static ushort m_devid = 0;	// foCXhcNA
		private static ushort m_swno = 0;

		// o͓b`̃`FbN{^̐ݒ`FbNp̕ϐ
		private static short m_latchcmd;
		private static short m_latchtimer;

//		private static uint[] m_BefRdTimer = new uint[2];			// O̓^C}lƒP
		private static uint m_BefTimerValue;	// O̓^C}l
		private static uint m_BefUnit;			// O̓^C}l̒P
											
		private static short m_BefOutStbDir;
		
        //Invoke\bhŎgpfQ[g                //hideki
        private delegate void MessageDelegate();

		public Form1()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			this.BoardMsg.Text = "{[hI[vĉB";

			this.BoardKind.SelectedIndex=3;			// {[h@PD5306P
			this.SwitchKind.SelectedIndex=0;		// XCb`ԍ@0
			// {[hAXCb`ԍR{{bNXLɂ
			this.BoardKind.Enabled = true;
			this.SwitchKind.Enabled = true;

			// o͓ZbgOUTSTB̃WI{^ݒ(オ)
			this.RadioOutStbUp.Checked = true;
			m_BefOutStbDir = 1;									// ۑpɗオZbg

			// o͓Zbg̏ݗ̏ݒ
			this.RadioWriteSlct1.Checked = true;				// S_o

			// o͓Zbg̃^C}R{{bNX̏l
			this.CmbTimer1.SelectedIndex=2;						// ^C}l@1000
			this.CmbUnit.SelectedIndex=1;						// Pʁ@ms

			// o͓Zbg̃`FbN{^̐ݒ`FbNp̕ϐ̏
			m_latchcmd = 0;										// ݒ
			m_latchtimer = 0;									// ݒ

			// ^C}P̎s̑O̒lێp
			m_BefTimerValue = 0;
			m_BefUnit = 0;
	
			// {[hI[v܂ł́Ao͓ZbgAo͒l݃{^A^C}P͖
			this.WriteButton.Enabled = false;					// o͒l
			this.OutputExeButton.Enabled = false;				// OUTSTBA
			this.Timer1ExeButton.Enabled = false;				// ^C}P
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.BoardKind = new System.Windows.Forms.ComboBox();
			this.SwitchKind = new System.Windows.Forms.ComboBox();
			this.OpenButton = new System.Windows.Forms.Button();
			this.CloseButton = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.CheckOtStbCmd = new System.Windows.Forms.CheckBox();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.CmbTimer1 = new System.Windows.Forms.ComboBox();
			this.label10 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.CmbUnit = new System.Windows.Forms.ComboBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.RadioOutStbUp = new System.Windows.Forms.RadioButton();
			this.RadioOutStbDown = new System.Windows.Forms.RadioButton();
			this.CheckTimer1 = new System.Windows.Forms.CheckBox();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.WriteButton = new System.Windows.Forms.Button();
			this.RadioWriteSlct1 = new System.Windows.Forms.RadioButton();
			this.RadioWriteSlct2 = new System.Windows.Forms.RadioButton();
			this.RadioWriteSlct3 = new System.Windows.Forms.RadioButton();
			this.RadioWriteSlct4 = new System.Windows.Forms.RadioButton();
			this.RadioWriteSlct5 = new System.Windows.Forms.RadioButton();
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.label8 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.OutputExeButton = new System.Windows.Forms.Button();
			this.Timer1ExeButton = new System.Windows.Forms.Button();
			this.label4 = new System.Windows.Forms.Label();
			this.Timer1Exe = new System.Windows.Forms.Label();
			this.UnitExe = new System.Windows.Forms.Label();
			this.BoardMsg = new System.Windows.Forms.Label();
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.groupBox1.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox4.SuspendLayout();
			this.groupBox5.SuspendLayout();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(32, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "{[h";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(144, 16);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(72, 16);
			this.label2.TabIndex = 0;
			this.label2.Text = "XCb`ԍ";
			// 
			// BoardKind
			// 
			this.BoardKind.Items.AddRange(new object[] {
														   "PD5006P",
														   "PD5106P",
														   "PD5206P",
														   "PD5306P"});
			this.BoardKind.Location = new System.Drawing.Point(24, 48);
			this.BoardKind.Name = "BoardKind";
			this.BoardKind.Size = new System.Drawing.Size(96, 20);
			this.BoardKind.TabIndex = 1;
			this.BoardKind.Text = "comboBox1";
			// 
			// SwitchKind
			// 
			this.SwitchKind.Items.AddRange(new object[] {
															"0",
															"1",
															"2",
															"3",
															"4",
															"5",
															"6",
															"7",
															"8",
															"9",
															"10",
															"11",
															"12",
															"13",
															"14",
															"15"});
			this.SwitchKind.Location = new System.Drawing.Point(144, 48);
			this.SwitchKind.Name = "SwitchKind";
			this.SwitchKind.Size = new System.Drawing.Size(96, 20);
			this.SwitchKind.TabIndex = 1;
			this.SwitchKind.Text = "comboBox1";
			// 
			// OpenButton
			// 
			this.OpenButton.Location = new System.Drawing.Point(288, 32);
			this.OpenButton.Name = "OpenButton";
			this.OpenButton.Size = new System.Drawing.Size(72, 24);
			this.OpenButton.TabIndex = 2;
			this.OpenButton.Text = "Open";
			this.OpenButton.Click += new System.EventHandler(this.OpenButton_Click);
			// 
			// CloseButton
			// 
			this.CloseButton.Location = new System.Drawing.Point(384, 32);
			this.CloseButton.Name = "CloseButton";
			this.CloseButton.Size = new System.Drawing.Size(72, 24);
			this.CloseButton.TabIndex = 2;
			this.CloseButton.Text = "Close";
			this.CloseButton.Click += new System.EventHandler(this.CloseButton_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.CheckOtStbCmd);
			this.groupBox1.Controls.Add(this.groupBox3);
			this.groupBox1.Controls.Add(this.groupBox2);
			this.groupBox1.Controls.Add(this.CheckTimer1);
			this.groupBox1.Location = new System.Drawing.Point(24, 128);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(496, 160);
			this.groupBox1.TabIndex = 3;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "o͓ZbgLݒ";
			// 
			// CheckOtStbCmd
			// 
			this.CheckOtStbCmd.Location = new System.Drawing.Point(8, 40);
			this.CheckOtStbCmd.Name = "CheckOtStbCmd";
			this.CheckOtStbCmd.Size = new System.Drawing.Size(232, 24);
			this.CheckOtStbCmd.TabIndex = 2;
			this.CheckOtStbCmd.Text = "OTSTBA߂ɂo͓ZbgL";
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.CmbTimer1);
			this.groupBox3.Controls.Add(this.label10);
			this.groupBox3.Controls.Add(this.label11);
			this.groupBox3.Controls.Add(this.CmbUnit);
			this.groupBox3.Location = new System.Drawing.Point(264, 80);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(208, 72);
			this.groupBox3.TabIndex = 1;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "^C}P";
			// 
			// CmbTimer1
			// 
			this.CmbTimer1.Items.AddRange(new object[] {
														   "0",
														   "500",
														   "1000",
														   "2000",
														   "3000",
														   "10000",
														   "32767"});
			this.CmbTimer1.Location = new System.Drawing.Point(8, 40);
			this.CmbTimer1.Name = "CmbTimer1";
			this.CmbTimer1.Size = new System.Drawing.Size(88, 20);
			this.CmbTimer1.TabIndex = 1;
			this.CmbTimer1.Text = "comboBox3";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(16, 24);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(72, 16);
			this.label10.TabIndex = 0;
			this.label10.Text = "l";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(112, 24);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(48, 16);
			this.label11.TabIndex = 0;
			this.label11.Text = "P";
			// 
			// CmbUnit
			// 
			this.CmbUnit.Items.AddRange(new object[] {
														 "s",
														 "ms"});
			this.CmbUnit.Location = new System.Drawing.Point(112, 40);
			this.CmbUnit.Name = "CmbUnit";
			this.CmbUnit.Size = new System.Drawing.Size(72, 20);
			this.CmbUnit.TabIndex = 1;
			this.CmbUnit.Text = "comboBox3";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.RadioOutStbUp);
			this.groupBox2.Controls.Add(this.RadioOutStbDown);
			this.groupBox2.Location = new System.Drawing.Point(264, 24);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(208, 48);
			this.groupBox2.TabIndex = 0;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "OTSTBω";
			// 
			// RadioOutStbUp
			// 
			this.RadioOutStbUp.Location = new System.Drawing.Point(16, 24);
			this.RadioOutStbUp.Name = "RadioOutStbUp";
			this.RadioOutStbUp.Size = new System.Drawing.Size(80, 16);
			this.RadioOutStbUp.TabIndex = 0;
			this.RadioOutStbUp.Text = "オ";
			// 
			// RadioOutStbDown
			// 
			this.RadioOutStbDown.Location = new System.Drawing.Point(112, 24);
			this.RadioOutStbDown.Name = "RadioOutStbDown";
			this.RadioOutStbDown.Size = new System.Drawing.Size(80, 16);
			this.RadioOutStbDown.TabIndex = 0;
			this.RadioOutStbDown.Text = "";
			// 
			// CheckTimer1
			// 
			this.CheckTimer1.Location = new System.Drawing.Point(8, 112);
			this.CheckTimer1.Name = "CheckTimer1";
			this.CheckTimer1.Size = new System.Drawing.Size(232, 24);
			this.CheckTimer1.TabIndex = 2;
			this.CheckTimer1.Text = "^C}Pɂo͓ZbgL";
			// 
			// groupBox4
			// 
			this.groupBox4.Controls.Add(this.WriteButton);
			this.groupBox4.Controls.Add(this.RadioWriteSlct1);
			this.groupBox4.Controls.Add(this.RadioWriteSlct2);
			this.groupBox4.Controls.Add(this.RadioWriteSlct3);
			this.groupBox4.Controls.Add(this.RadioWriteSlct4);
			this.groupBox4.Controls.Add(this.RadioWriteSlct5);
			this.groupBox4.Location = new System.Drawing.Point(24, 296);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(496, 144);
			this.groupBox4.TabIndex = 4;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "o̓f[^ݒ";
			// 
			// WriteButton
			// 
			this.WriteButton.Location = new System.Drawing.Point(368, 64);
			this.WriteButton.Name = "WriteButton";
			this.WriteButton.Size = new System.Drawing.Size(96, 24);
			this.WriteButton.TabIndex = 1;
			this.WriteButton.Text = "o͒l";
			this.WriteButton.Click += new System.EventHandler(this.WriteButton_Click);
			// 
			// RadioWriteSlct1
			// 
			this.RadioWriteSlct1.Location = new System.Drawing.Point(16, 24);
			this.RadioWriteSlct1.Name = "RadioWriteSlct1";
			this.RadioWriteSlct1.Size = new System.Drawing.Size(280, 16);
			this.RadioWriteSlct1.TabIndex = 0;
			this.RadioWriteSlct1.Text = "e|[g0xFFo(S_P)";
			// 
			// RadioWriteSlct2
			// 
			this.RadioWriteSlct2.Location = new System.Drawing.Point(16, 48);
			this.RadioWriteSlct2.Name = "RadioWriteSlct2";
			this.RadioWriteSlct2.Size = new System.Drawing.Size(280, 16);
			this.RadioWriteSlct2.TabIndex = 0;
			this.RadioWriteSlct2.Text = "e|[g0x00o(S_0)";
			// 
			// RadioWriteSlct3
			// 
			this.RadioWriteSlct3.Location = new System.Drawing.Point(16, 72);
			this.RadioWriteSlct3.Name = "RadioWriteSlct3";
			this.RadioWriteSlct3.Size = new System.Drawing.Size(280, 16);
			this.RadioWriteSlct3.TabIndex = 0;
			this.RadioWriteSlct3.Text = "e|[g0x01o(e|[gOOOOOOOPo)";
			// 
			// RadioWriteSlct4
			// 
			this.RadioWriteSlct4.Location = new System.Drawing.Point(16, 96);
			this.RadioWriteSlct4.Name = "RadioWriteSlct4";
			this.RadioWriteSlct4.Size = new System.Drawing.Size(280, 16);
			this.RadioWriteSlct4.TabIndex = 0;
			this.RadioWriteSlct4.Text = "e|[g0x55o(e|[gOPOPOPOPo)";
			// 
			// RadioWriteSlct5
			// 
			this.RadioWriteSlct5.Location = new System.Drawing.Point(16, 120);
			this.RadioWriteSlct5.Name = "RadioWriteSlct5";
			this.RadioWriteSlct5.Size = new System.Drawing.Size(280, 16);
			this.RadioWriteSlct5.TabIndex = 0;
			this.RadioWriteSlct5.Text = "e|[g0xAAo(e|[gPOPOPOPOo)";
			// 
			// groupBox5
			// 
			this.groupBox5.Controls.Add(this.label8);
			this.groupBox5.Controls.Add(this.label7);
			this.groupBox5.Controls.Add(this.label3);
			this.groupBox5.Controls.Add(this.OutputExeButton);
			this.groupBox5.Controls.Add(this.Timer1ExeButton);
			this.groupBox5.Controls.Add(this.label4);
			this.groupBox5.Controls.Add(this.Timer1Exe);
			this.groupBox5.Controls.Add(this.UnitExe);
			this.groupBox5.Location = new System.Drawing.Point(24, 448);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(496, 192);
			this.groupBox5.TabIndex = 5;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "groupBox5";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(24, 152);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(296, 32);
			this.label8.TabIndex = 3;
			this.label8.Text = "APD5106PPD5306P͓gp邱ƂłAWp[sŐ؂ւĎgp܂B";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(24, 112);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(456, 24);
			this.label7.TabIndex = 2;
			this.label7.Text = "uOTSTBA߂ɂo͓ZbgLv`FbNꍇAOTSTBMƖ߂̗ŏo͓Zbgł܂B";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(200, 48);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(72, 16);
			this.label3.TabIndex = 1;
			this.label3.Text = "o";
			// 
			// OutputExeButton
			// 
			this.OutputExeButton.Location = new System.Drawing.Point(16, 32);
			this.OutputExeButton.Name = "OutputExeButton";
			this.OutputExeButton.Size = new System.Drawing.Size(144, 24);
			this.OutputExeButton.TabIndex = 0;
			this.OutputExeButton.Text = "o͓Zbgߎs";
			this.OutputExeButton.Click += new System.EventHandler(this.OutputExeButton_Click);
			// 
			// Timer1ExeButton
			// 
			this.Timer1ExeButton.Location = new System.Drawing.Point(16, 72);
			this.Timer1ExeButton.Name = "Timer1ExeButton";
			this.Timer1ExeButton.Size = new System.Drawing.Size(144, 24);
			this.Timer1ExeButton.TabIndex = 0;
			this.Timer1ExeButton.Text = "^C}Ps";
			this.Timer1ExeButton.Click += new System.EventHandler(this.Timer1ExeButton_Click);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(304, 48);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(72, 16);
			this.label4.TabIndex = 1;
			this.label4.Text = "P";
			// 
			// Timer1Exe
			// 
			this.Timer1Exe.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.Timer1Exe.Location = new System.Drawing.Point(200, 72);
			this.Timer1Exe.Name = "Timer1Exe";
			this.Timer1Exe.Size = new System.Drawing.Size(72, 16);
			this.Timer1Exe.TabIndex = 1;
			// 
			// UnitExe
			// 
			this.UnitExe.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.UnitExe.Location = new System.Drawing.Point(304, 72);
			this.UnitExe.Name = "UnitExe";
			this.UnitExe.Size = new System.Drawing.Size(72, 16);
			this.UnitExe.TabIndex = 1;
			// 
			// BoardMsg
			// 
			this.BoardMsg.Location = new System.Drawing.Point(32, 80);
			this.BoardMsg.Name = "BoardMsg";
			this.BoardMsg.Size = new System.Drawing.Size(480, 24);
			this.BoardMsg.TabIndex = 6;
			this.BoardMsg.Text = "label9";
			// 
			// timer1
			// 
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(552, 654);
			this.Controls.Add(this.BoardMsg);
			this.Controls.Add(this.groupBox5);
			this.Controls.Add(this.groupBox4);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.OpenButton);
			this.Controls.Add(this.BoardKind);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.SwitchKind);
			this.Controls.Add(this.CloseButton);
			this.Name = "Form1";
			this.Text = "o͓ZbgTv";
			this.groupBox1.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			this.groupBox5.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		/// <summary>
		/// [Open]{^NbÑCxgnh
		/// {[hI[v
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OpenButton_Click(object sender, System.EventArgs e)
		{
		
			ushort	[] DeviceIDList = {(ushort)DEV.ID_PD5006P, (ushort)DEV.ID_PD5106P, (ushort)DEV.ID_PD5206P, (ushort)DEV.ID_PD5306P};
			m_devid = DeviceIDList[this.BoardKind.SelectedIndex];
			m_swno = ushort.Parse(this.SwitchKind.SelectedItem.ToString());
			// {[hI[viFfoCXhcAXCb`ԍA荞ݗLFLA{[hnh̃AhXj
			bool Ret = PD5000P.Dio_Open((DEV)m_devid,(ushort)m_swno, true, out m_hBoard);
    
			// G[
			if(Ret == false)
			{
				this.BoardMsg.Text = "I[vG[";
				ErrProc("I[v");;
				return;
			}   
			this.BoardMsg.Text = "I[v܂B";
    
			// MC5306P̏ꍇ(o64_)A{Tvpɏo64_ɂB
			if ((ushort)m_devid == (ushort)DEV.ID_PD5306P)
			{
				if (!(PD5000P.Dio_SetIoDir(m_hBoard, 0xffffffff, 0xffffffff))) 
				{
					ErrProc("o͐ݒ");
					return;
				}
				MessageBox.Show("S64_o͂ɂ܂B","PD5000P o͓ZbgTv", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
			}

			// {[hAXCb`ԍR{{bNX𖳌ɂiύXsɂj
			this.BoardKind.Enabled = false;
			this.SwitchKind.Enabled = false;

			// o͓Zbg̃`FbN{^̐ݒ`FbNp̕ϐ̏
			m_latchcmd = 0;									// ݒ
			m_latchtimer = 0;								// ݒ

			// ^C}P̎s̑O̒lێp
			m_BefTimerValue = 0;
			m_BefUnit = 0;

			{// OTSTBWI{^̏
				if (this.RadioOutStbUp.Checked == true)			// WI{^I
				{
					if (!(PD5000P.Dio_SetStrobeDir(m_hBoard, EDGE_TRG.EDGE_P, EDGE_TRG.EDGE_P)))
					{
						ErrProc("OXg[uMωݒ");
					}
					m_BefOutStbDir = 1;							// ۑpɗオZbg
				}
				else 
				{
					if (!(PD5000P.Dio_SetStrobeDir(m_hBoard, EDGE_TRG.EDGE_M, EDGE_TRG.EDGE_P)))
					{
						ErrProc("OXg[uMωݒ");
					}
					m_BefOutStbDir = 2;							// ۑpɗZbg
				}
			}

			// ^C}[Jn
			// WI{^(͕ωLA͕ω)̃XCb`ωmׂ̂̂łB
			// ͐Mԕ\p100msec^C}[Jn
			timer1.Start();


			// {[h̎ނɂāA^C}̏o͓ZbgLÂłɑΉ
			// PD5006PɊւẮA64_ׁ̈ATv𓮍삳Ȃ悤ɂĂ܂B
			switch ((ushort)m_devid) 
			{
				case (ushort)DEV.ID_PD5106P:
				case (ushort)DEV.ID_PD5306P:
					// {[hI[vꂽ̂ŁAo͒l݁Ao͓Zbg{^͗L
					this.WriteButton.Enabled = true;					// o͒l
					this.OutputExeButton.Enabled = true;				// OUTSTBA
					// PD5106P,PD5306P̓^C}ɂo͓Zbg͂Ȃ̂ŁA
					// ^C}֘Ã{^͑SĖɂ
					this.CheckTimer1.Enabled = false;			
					this.CmbTimer1.Enabled = false;			
					this.CmbUnit.Enabled = false;			
					this.Timer1Exe.Enabled = false;			
					this.UnitExe.Enabled = false;			

					break;
				case (ushort)DEV.ID_PD5206P:
					// {[hI[vꂽ̂ŁAo͒l݁Ao͓Zbg{^͗L
					this.WriteButton.Enabled = true;					// o͒l
					this.OutputExeButton.Enabled = true;				// OUTSTBA
					this.Timer1ExeButton.Enabled = true;				// ^C}P
					// PD5206P̓^C}ɂo͓ZbĝŁAL
					// ^C}֘Ã{^͑SėLɂ
					this.CheckTimer1.Enabled = true;			
					this.CmbTimer1.Enabled = true;			
					this.CmbUnit.Enabled = true;			
					this.Timer1Exe.Enabled = true;			
					this.UnitExe.Enabled = true;			

					break;
				case (ushort)DEV.ID_PD5006P:
					ErrProcEx("PD5006P͓64_ׁ̈A{Tv͋@\܂\nN[YĂ");
					break;
			}
		}

		/// <summary>
		/// [Close]{^NbÑCxgnh
		/// ݒʒmݒ
		/// {[hN[Y
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void CloseButton_Click(object sender, System.EventArgs e)
		{
			timer1.Dispose();											// ^C}[I

			if (!(PD5000P.Dio_SetSmlOutStbCmd(m_hBoard, 0)))			// o͓ZbgLݒ(OUTSTBA)F
			{
				ErrProc("o͓Zbgݒ(OUTSTBA)");
			}
			if ((ushort)m_devid == (ushort)DEV.ID_PD5206P)
			{
				if (!(PD5000P.Dio_SetSmlOutTimer(m_hBoard, 0)))			// o͓ZbgLݒ(^C})F
				{
					ErrProc("o͓Zbgݒ(^C})");
				}
			}

			// {[hN[YiF{[hnhj
			bool Ret = PD5000P.Dio_Close(m_hBoard);

			// G[
			if(Ret == false)
			{    
				this.BoardMsg.Text = "N[YG[";
				ErrProc("N[Y");
				return;
			}

			this.BoardMsg.Text = "N[Y܂B";					// {[hI[v֘ÃbZ[W

			// {[hAXCb`ԍR{{bNXLɂ
			this.BoardKind.Enabled = true;
			this.SwitchKind.Enabled = true;

			m_hBoard = 0;	// {[hnhNA
			m_devid = 0;	// foCXhcNA

			// o͓Zbg̃`FbN{^̐ݒ`FbNp̕ϐ̏
			m_latchcmd = 0;												// ݒ
			m_latchtimer = 0;											// ݒ
	
			// ^C}P̎s̑O̒lێp
			m_BefTimerValue = 0;
			m_BefUnit = 0;

			// {[hI[v܂ł́Ao͒l݁Ao͓Zbg{^A^C}P͖
			this.WriteButton.Enabled = false;							// o͒l
			this.OutputExeButton.Enabled = false;						// OUTSTBA
			this.Timer1ExeButton.Enabled = false;						// ^C}P

		}

		/// <summary>
		/// [o͒l]{^NbÑCxgnh
		/// o͒l
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void WriteButton_Click(object sender, System.EventArgs e)
		{
		
			if (this.RadioWriteSlct1.Checked == true)					// ݃p^[P`FbN
			{
				if (!(PD5000P.Dio_Out_8Byte(m_hBoard,0,0xffffffff,0xffffffff)))
					// S|[go͂P
				{
					ErrProc("o͖߂̎s");
				}
				return;
			}

			if (this.RadioWriteSlct2.Checked == true)					// ݃p^[Q`FbN
			{
				if (!(PD5000P.Dio_Out_8Byte(m_hBoard,0,0x00000000,0x00000000)))
					// S|[go͂O
				{
					ErrProc("o͖߂̎s");
				}
				return;
			}

			if (this.RadioWriteSlct3.Checked == true)					// ݃p^[R`FbN
			{
				if (!(PD5000P.Dio_Out_8Byte(m_hBoard,0,0x01010101,0x01010101)))
					// |[gO`VSNx0Pɂ
				{
					ErrProc("o͖߂̎s");
				}
				return;
			}

			if (this.RadioWriteSlct4.Checked == true)					// ݃p^[S`FbN
			{
				if (!(PD5000P.Dio_Out_8Byte(m_hBoard,0,0x55555555,0x55555555)))
					// e|[gOPOPOPOPɂ
				{
					ErrProc("o͖߂̎s");
				}
				return;
			}

			// LȊȌꍇ́AKc̃WI{^`FbNĂ͂

			if (!(PD5000P.Dio_Out_8Byte(m_hBoard,0,0xAAAAAAAA,0xAAAAAAAA)))
				// e|[gPOPOPOPOɂ
			{
				ErrProc("o͖߂̎s");
			}
		}

		/// <summary>
		/// [o͓Zbgߎs]{^NbÑCxgnh
		/// o͓Zbgߎs
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OutputExeButton_Click(object sender, System.EventArgs e)
		{
		
			if (this.CheckOtStbCmd.Checked == true)			// OUTSTBA߃`FbN{bNX
			{
				if (!(PD5000P.Dio_ExecSmlOut(m_hBoard)))	// o͓Zbg߂̎s
				{
					ErrProc("o͓Zbg߂̎s");
				}
			}
			else 
			{
				ErrProcEx("OTSTBA߂ɂo͓ZbgA\nLɂȂĂ܂");
				return;
			}
		}

		/// <summary>
		/// [^C}Ps]{^NbÑCxgnh
		/// ^C}Ps
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void Timer1ExeButton_Click(object sender, System.EventArgs e)
		{
			uint	TimerValue = 0;
			uint Unit;
			TSCALE	TimerUnit;

			if (this.CheckTimer1.Checked != true)					// ^C}P`FbN{bNX
			{
				ErrProcEx("^C}Pɂo͓ZbgA\nLɂȂĂ܂");
				return;
			}

			// ʂŐݒ肳Ă^C}l
			TimerValue = uint.Parse(this.CmbTimer1.SelectedItem.ToString());

			// ʂŐݒ肳ĂP
			Unit = uint.Parse(this.CmbUnit.SelectedIndex.ToString());
			if (Unit == 0)
				TimerUnit = TSCALE.MICRO;
			else
				TimerUnit = TSCALE.MILLI;

			// 荞ݒʒmݒi[U[֐gpjF{[hnhA荞݊֐
			PD5000P.callback[0] = new PD5000P.UserThread(IntrptFunc);
			if (!(PD5000P.Dio_SetEventFunc(m_hBoard, PD5000P.callback[0], m_hBoard)))	
			{
				ErrProc("Dio_SetEventFunc");
			}

			// F{[hnhA^C}ԍ(1)A^C}l(TimerValue)A^C}P(Unit)
			if(!(PD5000P.Dio_SetTimer(m_hBoard, TIMER.TIMER1, TimerValue, TimerUnit)))
																			// ^C}lݒi^C}Ƀ^C}lݒ肷j
			{
				ErrProc("Dio_SetTimer");
			}
    
			if(!(PD5000P.Dio_SetIntrptMode(m_hBoard, 0x00000020)))			// 荞ݐݒi^C}P̊荞݂Lɂj
			{
				ErrProc("Dio_SetIntrptMode");
			}

			if(!(PD5000P.Dio_StartTimer(m_hBoard, TIMER.TIMER1, TMODE.RUN_SINGLE)))
																			// ^C}Jn
			{
				ErrProc("Dio_StartTimer");
			}
		}

		/// <summary>
		/// 荞݊֐
		/// </summary>
		/// <remarks>
		/// 荞݊֐ł́A^C}PŊ荞݂ƂbZ[Wɕ\܂
		/// (b`̃^C~O킩悤ɂׂɁAbZ[W\Ă܂)
		/// </remarks>
		/// <param name="param">荞ݒʒmݒ֐(Dio_SetEventFunc)Őݒ肵3p[^</param>
		private void IntrptFunc(int param)
		{
			uint	IntrptData = 0;

			// 荞ݗvǂݏo
			if(PD5000P.Dio_ReadIntrpt(m_hBoard, out IntrptData))
			{
				if ((IntrptData & 0x20) == 0x20)						// 荞ݗv^C}Pł
				{
		            //// bZ[W{bNX\

		            //عްĂ쐬InvokeŌĂяoB

		            //MessageDelegate̍쐬       //hideki
		            MessageDelegate dlg = new MessageDelegate(message);

		            //MessageBoxɕǉ    //hideki
		            this.Invoke(dlg, new object[] {});

				}
			}
		}
		/// <summary>
		/// 荞ݏ[`̃bZ[W\
		/// ^C}PŊ荞݂ƂbZ[Wɕ\܂B
		/// <summary>
		private void message()
		{

            // bZ[W{bNX\
			MessageBox.Show(this,"^C}PŊ荞݂܂","PD5000P o͓ZbgTv", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);

			return;
		
		}

		/// <summary>
		/// ^C}
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void timer1_Tick(object sender, System.EventArgs e)
		{
			// `FbN{bNX̕ωɑ΂鏈
			// OUTSTBA߂ɂo͓ZbgL
			if (this.CheckOtStbCmd.Checked == true)				// OUTSTBA߃`FbN{bNX
			{
				if (m_latchcmd != 1)							// OƈႤ(VɃ`FbNꂽ)
				{
					if (!(PD5000P.Dio_SetSmlOutStbCmd(m_hBoard,ENABLED.TRUE)))
																// o͓ZbgLݒ(OUTSTBA)FL
					{
						ErrProc("o͓ZbgLݒ(OUTSTBA)");
					}
					m_latchcmd = 1;								// `FbNԂONɂ 
				}
			}
			else 
			{
				if (m_latchcmd != 2)							// OƈႤ(VɃ`FbN͂) 
				{
					if (!(PD5000P.Dio_SetSmlOutStbCmd(m_hBoard,ENABLED.FALSE)))
																// o͓ZbgLݒ(OUTSTBA)F
					{
						ErrProc("o͓ZbgLݒ(INSTBA)");
					}
					m_latchcmd = 2;								// `FbNԂOFFɂ 
				}
			}

			// ^C}ɂo͓ZbgL
			// `FbN{bNX̃`FbN
			// {[h`FbN
			if ((ushort)m_devid == (ushort)DEV.ID_PD5206P)
			{
				if (this.CheckTimer1.Checked == true)			// ^C}P`FbN{bNX
				{
					if (m_latchtimer != 1)						// OƈႤ(VɃ`FbNꂽ)
					{
						if (!(PD5000P.Dio_SetSmlOutTimer(m_hBoard,ENABLED.TRUE)))
																// o͓ZbgLݒ(^C})FL
						{
							ErrProc("o͓ZbgLݒ(^C})");
						}
						m_latchtimer = 1;						// `FbNԂONɂ
					}
				}
				else 
				{
					if (m_latchtimer != 2)						// OƈႤ(VɃ`FbN͂) 
					{
						if (!(PD5000P.Dio_SetSmlOutTimer(m_hBoard,ENABLED.FALSE)))
																// o͓ZbgLݒ(^C})F
						{
							ErrProc("o͓ZbgLݒ(^C})");
						}
						m_latchtimer = 2;						// `FbNԂOFFɂ
					}
				}
			}
			
			 // OTSTB̗オA`FbN
			if (this.RadioOutStbUp.Checked == true)				// OTSTBWI{^
			{
				if (m_BefOutStbDir != 1) 						// OƈႤ
				{
					if (!(PD5000P.Dio_SetStrobeDir(m_hBoard, EDGE_TRG.EDGE_P, EDGE_TRG.EDGE_P)))
					{
						ErrProc("OXg[uMωݒ");
					}
					m_BefOutStbDir = 1;
				}
			}
			else 
			{
				if (m_BefOutStbDir != 2) 						// OƈႤ
				{
					if (!(PD5000P.Dio_SetStrobeDir(m_hBoard, EDGE_TRG.EDGE_P, EDGE_TRG.EDGE_M)))
					{
						ErrProc("OXg[uMωݒ");
					}
					m_BefOutStbDir = 2;
				}
			}
			
			// o͓Zbg^C}oߎԕ\
			string []	TimerUnitStr = new string[] {"s", "ms"};	// ^C}l̒Pʕ
																
			uint	NowTimerValue;									// ̓^C}l
			uint	NowUnit;										// ̓^C}l̒P

			bool Ret = PD5000P.Dio_ReadCurrentTimer(m_hBoard, TIMER.TIMER1, out NowTimerValue, out NowUnit);	
			// ^C}lǂݏo
			if(Ret)												// 
			{
				// ݃f[^ƑOf[^قȂꍇ́A݃f[^ʕ\AOf[^ϐXVB
				if (NowTimerValue != m_BefTimerValue)			// ^C}l
				{
					this.Timer1Exe.Text = NowTimerValue.ToString();
					m_BefTimerValue = NowTimerValue;
				}
				if (NowUnit != m_BefUnit)			// P
				{
					this.UnitExe.Text = TimerUnitStr[NowUnit];
					m_BefUnit = NowUnit;
				}
			}
		}

		/// <summary>
		/// G[\iG[R[h擾AG[bZ[W\j
		/// </summary>
		/// <param name="FuncName">G[bZ[W</param>
		private void ErrProc(String FuncName)
		{
			Nmc_Status ErrCode;
			String	StrBuf;

			ErrCode = PD5000P.Dio_GetLastError();    // G[R[h擾
    
			StrBuf=FuncName + " G[I@G[R[h = " + ErrCode.ToString("X");;

			// G[bZ[W\ixj
			MessageBox.Show(this,StrBuf,"PD5000P o͓ZbgTv", MessageBoxButtons.OK, MessageBoxIcon.Error);
		}

		/// <summary>
		/// G[\iG[R[h擾AG[bZ[W\j
		/// </summary>
		/// <param name="FuncName">G[bZ[W</param>
		private void ErrProcEx(String FuncName)
		{
			// G[bZ[W\ixj
			MessageBox.Show(this,FuncName,"PD5000P o͓ZbgTv", MessageBoxButtons.OK, MessageBoxIcon.Error);
		}
	}
}
